/*
 *	LCD interface Sunlike SC2004(20 characters 4lines (80 character))only
 *
 *	This code will interface to a standard LCD controller
 *	like the Hitachi HD44780. It uses it in 4 bit mode, with
 *	the hardware connected as follows (the standard 14 pin 
 *	LCD connector is used):
 *	
 *	PORTA bits 0 to 4 are connected to the LCD data bits 4-7 (high nibble)
 *	PORTB bit 6 is connected to the LCD RS input (register select)
 *	PORTB bit 7 is connected to the LCD EN bit (enable)
 *	
 *	To use these routines, set up the port I/O (TRISA, TRISB) then
 *	call lcd_init(), then other routines as required.

	Correspond Hitech PIC C pro9.60pl4 build 3206 or higher
	by air variable Nov.30/2008

History
air variable Nov.30,2008
	Correspond Hitech PIC C pro9.60pl4 build 3206 or higher
air variable Dec.6,2008
	add LCD location counter "lcd_loccnt"
	add LCD_cgwrite
	PIC liteDelay֐PICC Propɂ
	__delayp̃NbNݒlcd.hŐݒ
air variable Dec.6,2008
	main.cŊǗĂLCD̕\ʒulcd.cōs
	ȉ̊֐ǉ
	s 0ŒPsA1ŉsȍ~
		void lcd_newline(uint8_t mode)
	iXy[X
		void lcd_space_full(uint8_t count)
	J[\
		void lcd_move(uint8_t arrow)
air variable Jan.12,2009
	fix lcd_init(void) routine
*/


//#include <xc8.h>
#include	"main.h"
#include	"lcd.h"
//#include	"delay.h"

//static bit LCD_RS	@ ((unsigned)&PORTB*8+6);	// Register select (RA6)
//static bit LCD_EN	@ ((unsigned)&PORTB*8+7);	// Enable (RA7)
//#define	LCD_STROBE	((LCD_EN = 1),(LCD_EN=0))	// spec. min 500ns ***fix 2009/11/17 air variable 

/* write a byte to the LCD in 4 bit mode */

void lcd_data_byteset(uint8_t c){
	LCD_UsePort = (uint8_t)((LCD_UsePort & LCD_PortMask) | (c & 0b00001111));		//Only low 4bit DATA
	LCD_STROBE;
}

void lcd_data_set(uint8_t c){
	LCD_UsePort = (uint8_t)((LCD_UsePort & LCD_PortMask) | ( (c >>4 ) & 0b00001111)) ;	//Hi SIDE DATA
	LCD_STROBE;
	LCD_UsePort = (uint8_t)((LCD_UsePort & LCD_PortMask) | (c & 0b00001111));		//low SIDE DATA
	LCD_STROBE;
}

void lcd_write(uint8_t c){
	LCD_RS = 0;
	LCD_UsePort = (uint8_t)((LCD_UsePort & LCD_PortMask) | ( (c >>4 ) & 0b00001111)) ;	//Hi SIDE DATA
	LCD_STROBE;
	LCD_UsePort = (uint8_t)((LCD_UsePort & LCD_PortMask) | (c & 0b00001111));		//low SIDE DATA
	LCD_STROBE;
//	DelayUs(40);
	__delay_us(40);	//PICC Pro
}

/*
 * 	Clear and home the LCD
 */

void lcd_clear(void){
	lcd_write(0x1);
	lcd_loccnt=0;
//	DelayMs(2);
	__delay_ms(2); //PICC Pro
}

/* write a string of chars to the LCD */

void lcd_puts(const char * s){
	LCD_RS = 1;	// write characters
	while(*s)
		lcd_putch(*s++);
}

/* write one character to the LCD and auto increment location counter*/

void lcd_putch(uint8_t c){
	LCD_RS = 1;	// write characters
	lcd_data_set(c);
	__delay_us(40);

	lcd_loccnt++;
	if		(lcd_loccnt == LCD_end_loc1+1){;	//1sڂȂ2sڂ
		lcd_goto(LCD_start_loc2);
		return;
	}
	else if	(lcd_loccnt == LCD_end_loc2+1){;	//2sڂȂ3sڂ
		lcd_goto(LCD_start_loc3);
		return;
	}
	else if	(lcd_loccnt == LCD_end_loc3+1){;	//3sڂȂ4sڂ
		lcd_goto(LCD_start_loc4);
		return;
	}
	else if	(lcd_loccnt == LCD_end_loc4+1){;	//4sڂȂ1sڂ
		lcd_goto(LCD_start_loc1);
		return;
	}	
}


//CG RAM[ݗp
void lcd_cgwrite(uint8_t c){
	LCD_RS = 1;	// write characters
	lcd_data_set(c);
	__delay_us(40);
}


/*
 * Go to the specified position
 */
void lcd_goto(uint8_t pos){
	lcd_write((uint8_t)(0x80+pos));
	lcd_loccnt=pos;
}
	
/* initialise the LCD - put into 4 bit mode */
void lcd_init(void){
	LCD_RS = 0;				// write control bytes
	__delay_ms(15);			// power on delay (PICC Pro)
	lcd_data_byteset(0x03);	// attention!
	__delay_ms(5);			//wait
	LCD_STROBE;				//strobe again
	__delay_us(100);		//wait
	LCD_STROBE;				//strobe again
	__delay_ms(5);			//wait
	lcd_data_byteset(0x02) ;// set 4 bit mode
	__delay_us(100);		//wait
	lcd_write(0x28);		// 4 bit mode, 1/16 duty, 5x8 font
	lcd_write(0x08);		// display off
	lcd_write(0x0F);		// display on, blink curson on
	lcd_write(0x06);		// entry mode
	lcd_loccnt=0;
}

//s 0ŒPsA1ŉsȍ~
void lcd_newline(uint8_t mode){
	switch (mode){
		case 1://sXy[X
		if		(lcd_loccnt < LCD_end_loc1+1){
			lcd_space_full(LCD_end_loc1-lcd_loccnt+1);//1s
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc3+1){
			lcd_space_full(LCD_end_loc3-lcd_loccnt+1);//3s
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc2+1){
			lcd_space_full(LCD_end_loc2-lcd_loccnt+1);//2s
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc4+1){
			lcd_space_full(LCD_end_loc4-lcd_loccnt+1);//4s
			return;
		}else return;

		default://Ps
		if		(lcd_loccnt < LCD_end_loc1+1){
			lcd_goto(LCD_start_loc2);	//1sڂȂ2sڂ
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc3+1){
			lcd_goto(LCD_start_loc4);	//3sڂȂ4sڂ
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc2+1){
			lcd_goto(LCD_start_loc3);	//2sڂȂ3sڂ
			return;
		}
		else if	(lcd_loccnt < LCD_end_loc4+1){
			lcd_goto(LCD_start_loc1);	//4sڂȂ1sڂ
			return;
		}
	}
}	

//iXy[X
void lcd_space_full(uint8_t count){
	while(count--){
		lcd_putch(' ');//space character write
	};
}		

//J[\
void lcd_move(uint8_t arrow){
	switch (arrow){
		case UP:	
		if		(lcd_loccnt < LCD_end_loc1+1)	lcd_goto(lcd_loccnt+0x54);
		else if	(lcd_loccnt < LCD_end_loc3+1)	lcd_goto(lcd_loccnt+0x2c);
		else if	(lcd_loccnt < LCD_end_loc2+1)	lcd_goto(lcd_loccnt-0x40);
		else if	(lcd_loccnt < LCD_end_loc4+1)	lcd_goto(lcd_loccnt-0x40);
		break;

		case DOWN:	
		if		(lcd_loccnt < LCD_end_loc1+1)	lcd_goto(lcd_loccnt+0x40);
		else if	(lcd_loccnt < LCD_end_loc3+1)	lcd_goto(lcd_loccnt+0x40);
		else if	(lcd_loccnt < LCD_end_loc2+1)	lcd_goto(lcd_loccnt-0x2c);
		else if	(lcd_loccnt < LCD_end_loc4+1)	lcd_goto(lcd_loccnt-0x54);
		break;
		
		case LEFT:
		if		(lcd_loccnt == LCD_start_loc1)	lcd_goto(LCD_end_loc4);	//1sڂȂ4sڂ
		else if	(lcd_loccnt == LCD_start_loc2)	lcd_goto(LCD_end_loc1);	//2sڂȂ1sڂ
		else if	(lcd_loccnt == LCD_start_loc3)	lcd_goto(LCD_end_loc2);	//3sڂȂ2sڂ
		else if	(lcd_loccnt == LCD_start_loc4)	lcd_goto(LCD_end_loc3);	//4sڂȂ3sڂ
		else 	lcd_goto(--lcd_loccnt);
		break;

		case RIGHT:
		if		(lcd_loccnt == LCD_end_loc1)	lcd_goto(LCD_start_loc2);	//1sڂȂ2sڂ
		else if	(lcd_loccnt == LCD_end_loc2)	lcd_goto(LCD_start_loc3);	//2sڂȂ3sڂ
		else if	(lcd_loccnt == LCD_end_loc3)	lcd_goto(LCD_start_loc4);	//3sڂȂ4sڂ
		else if	(lcd_loccnt == LCD_end_loc4)	lcd_goto(LCD_start_loc1);	//4sڂȂ1sڂ
		else 	lcd_goto(++lcd_loccnt);
		break;

		default :
		break;
	}
}		
