/*
 *	LCD interface header file
 *	See lcd.c for more info
 */

//LCD kind set -------------------------------
//choose use the LCD module model number

//#define	_LCD0802
//#define	_LCD1602
//#define	_LCD2402 
#define		_SC2004

/********************************************************/

//LCD address set
#define LCD_start_loc1	0x00
#define LCD_start_loc2	0x40
#define LCD_start_loc3	0x14
#define LCD_start_loc4	0x54

#define LCD_end_loc1	0x13
#define LCD_end_loc2	0x53
#define LCD_end_loc3	0x27
#define LCD_end_loc4	0x67
//#define LCD_lineSize	20

#define UP		1
#define	DOWN	2
#define	LEFT	4
#define	RIGHT	8


//LCD USE port assign ***1.50
#define	LCD_UsePort	LATC
//LCD mask parameter ***1.50
#define LCD_PortMask 0b11110000 //4bit mode 
//LCD control port assign ***1.50
#define LCD_RS LATAbits.LATA2
#define LCD_EN LATAbits.LATA0


//LCD location parameter
#define	LCD_LineNumber1	0x00
#define	LCD_LineNumber2	0x40
#define	LCD_LineNumber3	0x14
#define	LCD_LineNumber4	0x54

//LCD setting parameter
#define	LCD_CursorBlink	0x0f
#define	LCD_CursorOn	0x0e
#define	LCD_CursorOff	0x0c

//-LCD kind settings **1.20 -------------------------------
#ifdef	_LCD1602
#define	LCD_LineLength1	0x10
#endif
#ifdef	_LCD0802
#define	LCD_LineLength1	0x08
#endif
#ifdef	_LCD2402
#define	LCD_LineLength1	0x18
#endif
#ifdef	_SC2004
#define	LCD_LineLength1	20
#endif

#ifdef	_LCD0802
#define	VersionInfo	"ACM0802C"
#endif
#ifdef	_LCD1602
#define	VersionInfo	"SC1602BS "
#endif
#ifdef	_LCD2402
#define	VersionInfo	"SC242A(16F1823) "
#endif
#ifdef	_SC2004
#define	VersionInfo	"SC2004 "
#endif

// LCD function define
//#define	LCD_LineLength2	(LCD_LineLength1 + LCD_LineNumber2)	// **1.20
#define	LCD_STROBE	((LCD_EN = 1),(LCD_EN = 0))	// spec. min 500ns


/* write a byte to the LCD in 4 bit mode */

extern void lcd_write(uint8_t);

/* Clear and home the LCD */

extern void lcd_clear(void);

/* write a string of characters to the LCD */

extern void lcd_puts(const char * s);

/* Go to the specified position */

extern void lcd_goto(uint8_t pos);
	
/* intialize the LCD - call before anything else */

extern void lcd_init(void);

extern void lcd_putch(uint8_t);

/*	Set the cursor position */

#define	lcd_cursor(x)	lcd_write(((x)&0x7F)|0x80)

/*	Now LCD position memory */

uint16_t lcd_loccnt=0;	//fix by air variable 2009/11/17

/* CG RAM write data set */
extern void lcd_cgwrite(uint8_t);

//LCD new line 
extern void lcd_newline(uint8_t);

//LCD space full
void lcd_space_full(uint8_t);

//void lcd_cursor
extern void lcd_move(uint8_t arrow);
